//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop


#include "uMain.h"
#include "dllfunctionstypedefs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormCreate(TObject *Sender)
{
	dllHandle = LoadLibrary("msgBox.dll");
	if(dllHandle)
	{
		MBox = (MBOX)GetProcAddress(dllHandle, "MBox");
		if(MBox) bnMBoxCall->Enabled = true;
		else
		{
			bnMBoxCall->Enabled = false;
			ShowMessage("Unable to find function adress");
		}
	}
	else
	{
		bnMBoxCall->Enabled = false;
		ShowMessage("Unable to load msgBox.dll");
	}

    dll_NOP = LoadLibrary("CreateFile.dll");
	if(dll_NOP)
	{
		Nop = (NOP)GetProcAddress(dll_NOP, "Nop");
		if(Nop) bnCreateDLLCall->Enabled = true;
		else
		{
			bnCreateDLLCall->Enabled = false;
			ShowMessage("Unable to find function adress");
		}
	}
	else
	{
		bnCreateDLLCall->Enabled = false;
		ShowMessage("Unable to load CreateFile.dll");
	}

    dll_Report = LoadLibrary("Reporter.dll");
	if(dll_Report)
	{
		RemoveReport = (REMOVEREPORT)GetProcAddress(dll_Report, "RemoveReport");
		if(RemoveReport) bnReportCall->Enabled = true;
		else
		{
			bnReportCall->Enabled = false;
			ShowMessage("Unable to find \"RemoveReport\" adress");
		}
        OpenReport = (OPENREPORT)GetProcAddress(dll_Report, "OpenReport");
		if(OpenReport) bnReportCall->Enabled = true;
		else
		{
			bnReportCall->Enabled = false;
			ShowMessage("Unable to find \"OpenReport\" adress");
		}
	}
	else
	{
		bnReportCall->Enabled = false;
		ShowMessage("Unable to load Reporter.dll");
	}
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bnMBoxCallClick(TObject *Sender)
{
	MBox("  ","  exe");
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
    if(dll_NOP)
        FreeLibrary(dll_NOP);
        
	if(dllHandle)
		FreeLibrary(dllHandle);

    if(dll_Report)
        FreeLibrary(dll_Report);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bnCreateDLLCallClick(TObject *Sender)
{
    Nop("C:\\File.txt");
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bnReportCallClick(TObject *Sender)
{
    RemoveReport(Edit1->Text.c_str(),"C:\\1.rtf");
    OpenReport("C:\\1.rtf");
}
//---------------------------------------------------------------------------

